import java.io.*;
import java.util.*;

public class MaartenBufferedReader {
    public static void main(String[] args) throws IOException {
        try (BufferedReader reader = new BufferedReader(new InputStreamReader(System.in))) {
            new MaartenBufferedReader().run(reader);
        }
    }

    public void run(BufferedReader reader) throws IOException {
        String[] firstLine = reader.readLine().split(" ");
        int n = Integer.parseInt(firstLine[0]);
        int k = Integer.parseInt(firstLine[1]);

        int[][] sums = new int[n][2];
        for (int i = 0; i < n; i++) {
            sums[i][0] = i;
        }

        for (int i = 0; i < k; i++) {
            int j = 0;
            for (String r : reader.readLine().split(" ")) {
                sums[Integer.parseInt(r) - 1][1] += j++;
            }
        }

        Arrays.sort(sums, Comparator.comparingInt(pair -> pair[1]));

        for (int i = 0; i < n; i++) {
            System.out.println(sums[i][0] + 1);
        }
    }
}
