import java.util.*;

public class SolutionIvan {
    public static void main(String[] args) throws Exception {
        new SolutionIvan().run();
    }

    int n, m;
    List<String> block;

    void rotate() {
        List<String> newBlock = new ArrayList<>(m);
        for (int j = 0; j < m; ++j) {
            StringBuilder line = new StringBuilder();
            for (int i = 0; i < n; ++i) {
                line.append(block.get(n - i - 1).charAt(j));
            }
            newBlock.add(line.toString());
        }

        block = newBlock;
        n = block.size();
        m = block.get(0).length();
    }

    void print(List<String> b) {
        System.out.printf("%d %d\n", b.size(), b.get(0).length());
        for (String line : b) {
            System.out.println(line);
        }
    }
    void trySolve() {
        int lf = 0;
        int rg = m - 1;
        for (int i = 0; i < n; ++i) {
            int clf = block.get(i).indexOf('#');
            int crg = block.get(i).lastIndexOf('#');
            if (clf < lf || crg > rg) {
                return;
            }
            lf = clf;
            rg = crg;
        }

        for (int j = 0; j < m; ++j) {
            boolean dot = false;
            for (int i = 0; i < n; ++i) {
                if (block.get(i).charAt(j) == '#') {
                    if (dot) {
                        return;
                    }
                } else {
                    dot = true;
                }
            }
        }

        List<String> solution = new ArrayList<String>();
        for (int i = 0; i < n; ++i) {
            StringBuilder line = new StringBuilder();
            for (int j = 0; j < m; ++j) {
                line.append(block.get(i).charAt(j) == '#' ? '.' : '#');
            }
            solution.add(line.toString());
        }
        print(solution);
        System.exit(0);
    }

    void run() throws Exception {
        Scanner scanner = new Scanner(System.in);
        n = scanner.nextInt();
        m = scanner.nextInt();
        scanner.nextLine();
        block = new ArrayList<>(n);
        for (int i = 0; i < n; ++i) {
            block.add(scanner.nextLine());
        }

        for (int i = 0; i < 4; ++i) {
            rotate();
            trySolve();
        }

        System.out.println("impossible");
    }
}

